/* Xref gegegevens corrigeren Trigger t.b.v. ca-s_item */
  /*-- slechts eenmaal uitvoeren --*/
  IF CAN-FIND(FIRST sp-control WHERE 
                    sp-control.controlkode EQ 'ca-patch-03-update-ca-xref-tables'
                 OR sp-control.controlkode EQ 'ca-after-03-update-ca-xref-tables' )
  THEN RETURN.
  
  DO TRANSACTION ON ERROR UNDO, RETURN ERROR : 
    DEFINE BUFFER b-sp-crossref FOR sp-crossref.
    /* Bestaande Xref wegwerpen. */
    FOR EACH b-sp-crossref EXCLUSIVE-LOCK
       WHERE (b-sp-crossref.tabel EQ 'ca-s_item'                 AND b-sp-crossref.veldnaam EQ 'dacode') 
          OR (b-sp-crossref.tabel EQ 'ca-u_shipment_item_tariff' AND b-sp-crossref.veldnaam EQ 'item_seqnr'):
        DELETE b-sp-crossref .
    END.
    
    /* Voeg Toe nieuwe definitie. */
    CREATE b-sp-crossref.
    ASSIGN 
     b-sp-crossref.tabel = 'ca-s_item'
     b-sp-crossref.veldnaam = 'dacode'
     b-sp-crossref.rel_tabel = 'ca-s_dacode'
     b-sp-crossref.rel_veld = 'linecode'
     b-sp-crossref.volgnr = 1
     b-sp-crossref.van_veld = 'linecode'
     b-sp-crossref.delete-policy = 'Restrict'
     .
   
    CREATE b-sp-crossref.
    ASSIGN 
     b-sp-crossref.tabel = 'ca-s_item'
     b-sp-crossref.veldnaam = 'dacode'
     b-sp-crossref.rel_tabel = 'ca-s_dacode'
     b-sp-crossref.rel_veld = 'dacode'
     b-sp-crossref.volgnr = 2
     b-sp-crossref.van_veld = 'dacode'
     b-sp-crossref.delete-policy = 'Restrict'
     .
   
    CREATE b-sp-crossref.
    ASSIGN 
     b-sp-crossref.tabel = 'ca-s_item'
     b-sp-crossref.veldnaam = 'dacode'
     b-sp-crossref.volgnr = 999
     .
     
    CREATE b-sp-crossref.
    ASSIGN 
     b-sp-crossref.tabel = 'ca-u_shipment_item_tariff'
     b-sp-crossref.veldnaam = 'item_seqnr'
     b-sp-crossref.rel_tabel = 'ca-u_shipment_item'
     b-sp-crossref.rel_veld = 'shipment_seqnr'
     b-sp-crossref.volgnr = 1
     b-sp-crossref.van_veld = 'shipment_seqnr'
     b-sp-crossref.delete-policy = 'Cascade'
     .
   
    CREATE b-sp-crossref.
    ASSIGN 
     b-sp-crossref.tabel = 'ca-u_shipment_item_tariff'
     b-sp-crossref.veldnaam = 'item_seqnr'
     b-sp-crossref.rel_tabel = 'ca-u_shipment_item'
     b-sp-crossref.rel_veld = 'item_seqnr'
     b-sp-crossref.volgnr = 2
     b-sp-crossref.van_veld = 'item_seqnr'
     b-sp-crossref.delete-policy = 'Cascade'
     .
   
    CREATE b-sp-crossref.
    ASSIGN 
     b-sp-crossref.tabel = 'ca-u_shipment_item_tariff'
     b-sp-crossref.veldnaam = 'item_seqnr'
     b-sp-crossref.volgnr = 999
     .
     /*-- registreren voor toekomstige runs --*/
     CREATE sp-control.
     ASSIGN sp-control.controlkode = 'ca-patch-03-update-ca-xref-tables'
            sp-control.lijst       = 'uitgevoerd op ' + STRING(TODAY,'99-99-9999') + ' ' + STRING(TIME,'HH:MM:SS')
            sp-control.uitleg      = 'corrupte Xref verwijzingen corrigeren'.
  END. /* DO TRANSACTION */
