/******************************************************************************
   Alle ca-u_tariff wordt het nieuwe veld ind_auto_surcharges (ind_mandatory vanaf 12.02)
   default op yes gezet, maar moet no zijn.
*******************************************************************************/
DEF VAR cProgram        AS CHAR   NO-UNDO.
DEF VAR cAction         AS CHAR   NO-UNDO.
DEF VAR cTable          AS CHAR   NO-UNDO.
DEF VAR iTotal          AS INT    NO-UNDO.
DEF VAR iDone           AS INT    NO-UNDO.
DEF VAR iModulo         AS INT    NO-UNDO.
DEF VAR hBuf            AS HANDLE NO-UNDO.
DEF VAR hFld            AS HANDLE NO-UNDO.

/*--indien al een keer uitgevoerd, dan overslaan --*/
IF CAN-FIND(FIRST sp-control WHERE
                  sp-control.controlkode EQ THIS-PROCEDURE:FILE-NAME )
THEN RETURN.

ASSIGN cProgram = THIS-PROCEDURE:FILE-NAME
       cAction  = ''
       iModulo  = 100.  /* om de 100 records info tonen */

FORM 'Program  :' AT 1 cProgram   NO-LABEL  FORMAT 'x(50)'    AT 12  SKIP
     'Action   :' AT 1 cAction    NO-LABEL  FORMAT 'x(50)'    AT 12  SKIP
     'Table    :' AT 1 cTable     NO-LABEL  FORMAT 'x(50)'    AT 12  SKIP
     'Total    :' AT 1 iTotal     NO-LABEL  FORMAT '9999999'  AT 12  SKIP
     'Done     :' AT 1 iDone      NO-LABEL  FORMAT '9999999'  AT 12  SKIP   
     WITH FRAME a.

&GLOBAL-DEFINE mydisplay cProgram cAction cTable iTotal iDone  WITH FRAME a

/*****************************************************************************************************
   EVEN TELLEN, 
*****************************************************************************************************/
cAction = 'Counting..' .
cTable  = 'ca-u_tariff'. 
DISPLAY {&mydisplay}.
FOR EACH ca-u_tariff NO-LOCK:
   iTotal = iTotal + 1.
   IF iTotal MODULO iModulo EQ 0 
   THEN DISPLAY {&mydisplay}.
END.

/*****************************************************************************************************
 MAIN BLOCK
 *****************************************************************************************************/
ASSIGN cTable  = 'ca-u_tariff'
       cAction = 'Resetting mandatory field'.
DISPLAY {&mydisplay}.

/*--ivm met performance triggers disablen --*/
DISABLE TRIGGERS FOR LOAD OF ca-u_tariff.

tariff:
FOR EACH ca-u_tariff EXCLUSIVE-LOCK TRANSACTION:
   ASSIGN 
      hBuf  = BUFFER ca-u_tariff:HANDLE
      iDone = iDone + 1.
   IF iDone MODULO iModulo EQ 0 
   THEN DISPLAY {&mydisplay}.
   
   ASSIGN
      hFld  = hBuf:BUFFER-FIELD('ind_auto_surcharges') NO-ERROR.   
   IF NOT VALID-HANDLE(hFld) 
   THEN hFld  = hBuf:BUFFER-FIELD('ind_mandatory') NO-ERROR.
   IF NOT VALID-HANDLE(hFld) 
   THEN NEXT tariff.
   
   ASSIGN
      hFld:BUFFER-VALUE = NO.
   
END. /*each */

/*****************************************************************************************************
     registreren voor toekomstige runs dat deze script al is uitgevoerd en kan worden overgeslagen
*****************************************************************************************************/
ASSIGN cTable  = ''
       cAction = 'Done...' .
DISPLAY {&mydisplay}.

DO TRANSACTION:
   CREATE sp-control.
   ASSIGN sp-control.controlkode = THIS-PROCEDURE:FILE-NAME
          sp-control.lijst       = 'uitgevoerd op ' + STRING(TODAY,'99-99-9999') + ' ' + STRING(TIME,'HH:MM:SS')
          sp-control.uitleg      = 'fill empty ca-u_tariff.qualifier with default SEA/OCEAN TRIP'.
END. /*transaction*/
                    

