/*--indien al een keer uitgevoerd, dan overslaan --*/
IF CAN-FIND(FIRST sp-control WHERE
                  sp-control.controlkode EQ THIS-PROCEDURE:FILE-NAME )
THEN RETURN.


DEF VAR cProgram                      AS CHAR NO-UNDO.
DEF VAR cAction                       AS CHAR NO-UNDO.
DEF VAR cTable                        AS CHAR NO-UNDO.
DEF VAR iTotal                        AS INT  NO-UNDO.
DEF VAR iDone                         AS INT  NO-UNDO.
DEF VAR iModulo                       AS INT  NO-UNDO.

ASSIGN cProgram =  THIS-PROCEDURE:FILE-NAME
       cAction  = ''
       iModulo  =  100.  /* om de 100 records info tonen */

FORM 'Program  :' AT 1 cProgram   NO-LABEL  FORMAT 'x(50)'    AT 12  SKIP
     'Action   :' AT 1 cAction    NO-LABEL  FORMAT 'x(50)'    AT 12  SKIP
     'Table    :' AT 1 cTable     NO-LABEL  FORMAT 'x(50)'    AT 12  SKIP
     'Total    :' AT 1 iTotal     NO-LABEL  FORMAT '9999999'  AT 12  SKIP
     'Done     :' AT 1 iDone      NO-LABEL  FORMAT '9999999'  AT 12  SKIP   
     WITH FRAME a.

&GLOBAL-DEFINE mydisplay cProgram cAction cTable iTotal iDone  WITH FRAME a

ASSIGN cTable  = ''
       cAction = 'Counting..' .
DISPLAY {&mydisplay}.
/*****************************************************************************************************
   EVEN TELLEN, niet echt noodzakelijk ..
*****************************************************************************************************/
iTotal = 0.

/*****************************************************************************************************
 *****************************************************************************************************/
ASSIGN cTable  = 'ca-report'
       cAction = 'updating Vessel Admin Reports' .
DISPLAY {&mydisplay}.

/*-- l_&d_location_arg maken deel uit van indexen, dus index afdwingen waar die niet inzit, anders
     doorlopen we alles net zolang totdat er geen wijzigingen meer zijn --*/
ASSIGN iDone = 0.
DEF VAR iReport AS INT NO-UNDO.
DEF VAR cReports AS CHAR INIT "CA\report\ca-s_balance.rpt,CA\report\ca-s_item-open.rpt,CA\report\ca-s_result_vessel.rpt,CA\report\ca-s_result_period.rpt,CA\report\ca-s_item-open-ultimo.rpt,CA\report\ca-s_balance-ultimo.rpt" NO-UNDO.
DEF VAR cDescr   AS CHAR INIT "DA Balance,DA Open Items,Results per Voyage,Results per period,Open Items per ultimo period,Balance per ultimo period" NO-UNDO.

DEF VAR cReport AS CHAR NO-UNDO.


DEFINE BUFFER b-ca-report FOR ca-report .
/*--ivm met performance triggers disablen --*/
DISABLE TRIGGERS FOR LOAD OF ca-report.

DO TRANSACTION:
FOR EACH sp-company NO-LOCK:

  DO iReport = 1 TO NUM-ENTRIES(cReports) :

    cReport = ENTRY(iReport,cReports).
    
    FIND b-ca-report WHERE  
         b-ca-report.companycode EQ sp-company.companycode
     AND b-ca-report.reportname  EQ cReport
     EXCLUSIVE-LOCK NO-ERROR.

    IF NOT AVAILABLE b-ca-report
    THEN CREATE b-ca-report.

    ASSIGN 
      b-ca-report.companycode = sp-company.companycode
      b-ca-report.reportnr    = 99 + iReport
      b-ca-report.ordernr     = 0
      b-ca-report.reportgroup = 'Statistics-S'
      b-ca-report.reportname  = cReport
      b-ca-report.des         = ENTRY(iReport,cDescr)
      b-ca-report.type        = 'Crystal 10'
      b-ca-report.category    = 'ADMIN'
      .
    
      ASSIGN iDone = iDone + 1 .
   
   IF iDone MODULO iModulo EQ 0 
   THEN DISPLAY {&mydisplay}.       

  END. /*-- DO --*/
  

END. /*each ca-u_tariff*/
END. /*transaction*/


/*****************************************************************************************************
     registreren voor toekomstige runs dat deze script al is uitgevoerd en kan worden overgeslagen
*****************************************************************************************************/
ASSIGN cTable  = ''
       cAction = 'Done...' .
DISPLAY {&mydisplay}.

DO TRANSACTION:
   CREATE sp-control.
   ASSIGN sp-control.controlkode = THIS-PROCEDURE:FILE-NAME
          sp-control.lijst       = 'uitgevoerd op ' + STRING(TODAY,'99-99-9999') + ' ' + STRING(TIME,'HH:MM:SS')
          sp-control.uitleg      = 'Create room for terminal locations & citypostalcode locations'.
END. /*transaction*/
                    

   
